// WebBrowserContainer.cpp
// (c) 2003-2004 exeal

#include "StdAfx.h"
#include "WebBrowserContainer.h"
#include "AlphaEditController.h"
#include "../Armaiti/ComBasic.h"
using Alpha::CWebBrowserContainer;
using Alpha::CAlphaEditController;
using Armaiti::CComPtr;
using namespace std;


///	RXgN^
CWebBrowserContainer::CWebBrowserContainer() : m_pBrowser(0) {
}

///	fXgN^
CWebBrowserContainer::~CWebBrowserContainer() {
	if(m_pBrowser != 0)
		m_pBrowser->Release();
}

/**
 *	EBhE쐬
 *	@param hwndParent	eEBhE
 *	@param dwStyle		EBhEX^C (CreateWindow Ɠ)
 *	@param dwExStyle	gEBhEX^C (CreateWindowEx Ɠ)
 *	@return				
 */
bool CWebBrowserContainer::Create(HWND hwndParent, DWORD dwStyle, DWORD dwExStyle) {
	if(m_pBrowser != 0)
		return false;
	if(!toBoolean(::IsWindow(hwndParent)))
		return false;

#define CLEANUP_IF_FAILED()		\
	if(FAILED(hr)) {			\
		m_pBrowser->Release();	\
		m_pBrowser = 0;			\
		return false;			\
	}

	HRESULT	hr;
	hr = ::CoCreateInstance(CLSID_WebBrowser, 0, CLSCTX_ALL, IID_IWebBrowser2, reinterpret_cast<void**>(&m_pBrowser));
	if(FAILED(hr))
		return false;

	CComPtr<IOleObject>	pOleObject;
	hr = m_pBrowser->QueryInterface(IID_IOleObject, reinterpret_cast<void**>(&pOleObject));
	CLEANUP_IF_FAILED();
	hr = pOleObject->SetClientSite(this);
	CLEANUP_IF_FAILED();
	hr = pOleObject->DoVerb(OLEIVERB_INPLACEACTIVATE, 0, this, 0, hwndParent, 0);
	CLEANUP_IF_FAILED();

	HWND	hWnd;
	hr = m_pBrowser->get_HWND(reinterpret_cast<SHANDLE_PTR*>(&hWnd));
	CLEANUP_IF_FAILED();
	::SetWindowLong(hWnd, GWL_STYLE, dwStyle);
	::SetWindowLong(hWnd, GWL_EXSTYLE, dwExStyle);

	return true;
}

///	@see	IDocumentContainer::DeleteInstance
void CWebBrowserContainer::DeleteInstance() {
	delete this;
}

///	@see	IOleClientSite::GetContainer
STDMETHODIMP CWebBrowserContainer::GetContainer(IOleContainer** ppContainer) {
	VERIFY_POINTER(ppContainer);
	*ppContainer = 0;
	return E_NOINTERFACE;
}

///	@see	IDocumentContainer::GetDescription
wstring CWebBrowserContainer::GetDescription() const {
	BSTR	bstr;

	if(SUCCEEDED(m_pBrowser->get_LocationURL(&bstr))) {
		const wstring	str = bstr;
		::SysFreeString(bstr);
		return str;
	} else
		return L"";
}

///	@see	IDocumentContainer::GetFilePath
wstring CWebBrowserContainer::GetFilePath() const {
	return GetDescription();
}

///	@see	IOleClientSite::GetMoniker
STDMETHODIMP CWebBrowserContainer::GetMoniker(DWORD dwAssign, DWORD dwWhichMoniker, IMoniker** ppmk) {
	VERIFY_POINTER(ppmk);
	*ppmk = 0;
	return E_NOTIMPL;
}

///	@see	IDocumentContainer::GetTextEditor
CAlphaEditController* CWebBrowserContainer::GetTextEditor() const {
	return 0;
}

///	@see	IDocumentContainer::GetTitle
wstring CWebBrowserContainer::GetTitle() const {
	BSTR	bstr;

	if(SUCCEEDED(m_pBrowser->get_LocationName(&bstr))) {
		const wstring	str = bstr;
		::SysFreeString(bstr);
		return str;
	} else
		return L"";
}

///	@see	IDocumentContainer::GetWindow
HWND CWebBrowserContainer::GetWindow() const {
	HWND	hWnd;
	m_pBrowser->get_HWND(reinterpret_cast<SHANDLE_PTR*>(&hWnd));
	return hWnd;
}

///	Õy[Wɖ߂
void CWebBrowserContainer::GoBack() {
	m_pBrowser->GoBack();
}

///	̃y[Wɐi
void CWebBrowserContainer::GoForward() {
	m_pBrowser->GoForward();
}

///	z[y[W\
void CWebBrowserContainer::GoHome() {
	m_pBrowser->GoHome();
}

/**
 *	w肵 URI Ɉړ
 *	@param pwszUri	URI
 */
void CWebBrowserContainer::Navigate(const wchar_t* pwszUri) {
	assert(pwszUri);
	m_pBrowser->Navigate(const_cast<wchar_t*>(pwszUri), 0, 0, 0, 0);
}

///	@see	IDocumentContainer::OnActivate
void CWebBrowserContainer::OnActivate(bool bActive) {
	m_pBrowser->put_Visible(toVariantBoolean(bActive));
}

///	@see	IOleClientSite::OnShowWindow
STDMETHODIMP CWebBrowserContainer::OnShowWindow(BOOL fShow) {
	return S_OK;
}

///	@see	IDocumentContainer::RefreshWindow
void CWebBrowserContainer::RefreshWindow() {
	m_pBrowser->Refresh();
}

///	@see	IOleClientSite::RequestNewObjectLayout
STDMETHODIMP CWebBrowserContainer::RequestNewObjectLayout() {
	return E_NOTIMPL;
}

///	@see	IOleClientSite::SaveObject
STDMETHODIMP CWebBrowserContainer::SaveObject() {
	return E_NOTIMPL;
}

///	@see	IOleClientSite::ShowObject
STDMETHODIMP CWebBrowserContainer::ShowObject() {
	return S_OK;
}


/* [EOF] */